class PhotosController < ApplicationController
  before_action :set_photo, only: [:show, :edit, :update, :destroy, :localize_as, :create_guidepost_and_localize_as ]

  # GET /photos
  # GET /photos.json
  def index
    @photos = Photo.all
  end

  # GET /photos/1
  # GET /photos/1.json
  def show
    @guideposts_nearby = @photo.guideposts_nearby(2000)
    @osm_guideposts_nearby  = @photo.osm_guideposts_nearby(2000)
  end

  # GET /photos/new
  def new
    @photo = Photo.new
  end

  # GET /photos/1/edit
  def edit
  end

  # POST /photos
  # POST /photos.json
  def create
    @photo = Photo.new(photo_params)
    @auto_attach = (params[:auto_attach] == '1' )
    mess = ''
    
    respond_to do |format|
      if @photo.save
        if @auto_attach
          if @photo.auto_attach
            @photo.save
            mess = 'Fotka byla automaticky připojena.'
          else
            mess = 'Fotka nebyla automaticky připojena, nepodařilo se jasné určit rozcestník.'
          end
        end
        format.html { redirect_to @photo, notice: mess+'Photo was successfully created.' }
        format.json { render action: 'show', status: :created, location: @photo }
      else
        format.html { render action: 'new' }
        format.json { render json: @photo.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /photos/1
  # PATCH/PUT /photos/1.json
  def update
    respond_to do |format|
      if @photo.update(photo_params)
        format.html { redirect_to @photo, notice: 'Photo was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: 'edit' }
        format.json { render json: @photo.errors, status: :unprocessable_entity }
      end
    end
  end

  def localize_as
    @guidepost = Guidepost.find(params[:guidepost])
    @photo.guidepost = @guidepost
    @photo.save!
    redirect_to photo_path(@photo)
  end
  
  def create_guidepost_and_localize_as
    @osm_guidepost = OsmGuidepost.find(params[:osm_guidepost])
    @photo.osm_guidepost = @osm_guidepost
    @photo.save!
    redirect_to photo_path(@photo)
  end
  
  # DELETE /photos/1
  # DELETE /photos/1.json
  def destroy
    @photo.destroy
    respond_to do |format|
      format.html { redirect_to photos_url }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_photo
      @photo = Photo.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def photo_params
      params.require(:photo).permit(:image,:guidepost_id)
    end
end
